﻿using System;
using Microsoft.SharePoint.Utilities;

namespace RH.NoBlogCommentSpam
{
    public class NoBlogCommentProperty
    {
        public string WebUrl { get; set; }
        public Guid ListId { get; set; }
        public bool ApproveNonAnonymousComments { get; set; }
        public bool TitleRecycle { get; set; }
        public bool BodyRecycle { get; set; }
        public bool UrlMatch { get; set; }

        public NoBlogCommentProperty()
        {
        }

        /// <summary>
        /// properties are pasted as ; seperated string
        /// </summary>
        /// <param name="properties"></param>
        public NoBlogCommentProperty(string properties)
        {
            var strings = properties.Split(';');
            if (strings.Length != 6) return;

            WebUrl = SPEncode.UrlDecodeAsUrl(strings[0]);
            ListId = new Guid(strings[1]);
            ApproveNonAnonymousComments = (strings[2] == "1");
            TitleRecycle = (strings[3] == "1");
            BodyRecycle = (strings[4] == "1");
            UrlMatch = (strings[5] == "1");
        }

        /// <summary>
        /// Returns ; seperated string with all properties
        /// </summary>
        /// <returns>url;listid;1|0;1|0;1|0;1|0</returns>
        public override string ToString()
        {
            var str = string.Format("{0};{1};{2};{3};{4};{5}",
                                    SPEncode.UrlEncode(WebUrl),
                                    ListId,
                                    ApproveNonAnonymousComments ? 1 : 0,
                                    TitleRecycle ? 1 : 0,
                                    BodyRecycle ? 1 : 0,
                                    UrlMatch ? 1 : 0);
            return str;
        }
    }
}
